PROGRAM Disk_Utility;
{$P-}
{************** Type - Definitionen ************************}
TYPE
  bpb_type      = array[1..9] of integer;
  bpb_ptr       = ^bpb_type;
  dir_sector    = packed array[1..16,0..31] of byte;
  fat_type      = packed array[0..5260] of byte;

{************** Variablen - Deklerationen ******************}
VAR
  bpb                   : bpb_ptr;
  dir_buf               : array[1..9] of dir_sector;
  fat                   : fat_type;
  fat_1,fat_2,daten,
  dir,side,track,
  abs_sec,rel_sec,
  clusters,last_cluster,
  dir_side,dir_sec,x,y,
  dir_track,e,lw,l,tas  : integer;
  adr1,adr2,size,taste  : long_integer;
  k                     : byte;
  ch,laufw,ausga        : char;
  f1,f2,return_flag     : boolean;
  message               : string [10];

{************ BIOS & XBIOS - Funktionen **********************}

FUNCTION bconin(l:integer):long_integer;
  BIOS(2);

FUNCTION get_bpb(drive:integer):bpb_ptr;
   BIOS(7);

FUNCTION floprd(var buffer:dir_sector; f:long_integer;
                drv,sec,trk,sd,ct:integer):integer;
   XBIOS(8);

FUNCTION fatrd(VAR buffer:fat_type; f:long_integer;
                drv,sec,trk,sd,ct:integer):integer;
   XBIOS(8);

FUNCTION next_cluster(last_cluster:integer):integer;

VAR  i,w   : integer;

BEGIN
  i:=trunc(last_cluster*1.5);
  w:=fat[i]+fat[i+1]*256;
  if odd(last_cluster) then w:=shr(w,4);
  next_cluster:=w & $FFF;
END;

{*********** BILDSCHIRM - Steuerung *************************}

PROCEDURE cls;
BEGIN
  write(chr(27),'E');    { Lscht den Bildschirm  }
END; { cls }

PROCEDURE gotoxy (x,y : integer);
BEGIN
  write(chr(27),'Y',chr(32+y),chr(32+x));    { Corsor Positionieren }
END; { gotoxy }

PROCEDURE cur_on;
BEGIN
  write(chr(27),'e');
END;

PROCEDURE cur_off;
BEGIN
 write(chr(27),'f');
END;

PROCEDURE invers_on;
BEGIN
 write(chr(27),'p');
END;

PROCEDURE invers_off;
BEGIN
 write(chr(27),'q');
END;

PROCEDURE new_page;
BEGIN
 IF (ausga<>'D') then
  BEGIN
   invers_on;
   gotoxy (4,24);
   write(' Press any key ... ');
   read (ch);
   invers_off;
   cls;
  END;
END;
{***** PEEK & POKE  (Zusatz-LINK-File: 'PEEKPOKE.O' *****}

FUNCTION s_peek_b (adresse: LONG_INTEGER): BYTE;
  EXTERNAL;
PROCEDURE s_poke_b (adresse: LONG_INTEGER; wert: BYTE);
  EXTERNAL;

{************* Disk - schreib/lese EinsteLlung **********}

PROCEDURE disk_j;
BEGIN
cur_off;
  return_flag:=false;
  cls;
  gotoxy (0,5);
writeln('              ****************************************************');
writeln('              *                                                  *');
writeln('              *     Diskettenparameter : ATARI 260ST/520ST+      *');
writeln('              *                                                  *');
writeln('              *     Disketten-Lese-Modus (B:5.25 Zoll)           *');
writeln('              *                 - Modus  eingeschaltet  <1>      *');
writeln('              *                                                  *');
writeln('              *                                                  *');
writeln('              *     Disketten-Schreib-Modus                      *');
writeln('              *          Verify - Modus     geschaltet  <2>      *');
writeln('              *                                                  *');
writeln('              *                                                  *');
writeln('              *     Zurck  zum   M E N U E             <Q>      *');
writeln('              *                                                  *');
writeln('              ****************************************************');
cur_on;
invers_on;
  repeat
    adr1:=$a0d;
    if (s_peek_b (adr1) & $ff)=3 then
    begin
      message:='ATARI';
      f1:=true;
    end
      else
      begin
        message:='  IBM';
        f1:=false;
      end;
    gotoxy (26,10);
    write (message);
    adr2:=$444;
    if (s_peek_b (adr2) & $ff)=$ff then
    begin
      message:='ein';
      f2:=true;
    end
      else
      begin
        message:='aus';
        f2:=false;
      end;
    gotoxy (41,14);
    write (message);
    gotoxy (60,17);
    write (' ');
    gotoxy (60,17);
   read (ch);
   if ch=chr(27) then ch:='q';
       case ch of
              '1' : begin
                  if f1 then s_poke_b (adr1,0)
                    else s_poke_b (adr1,3);
                end;
              '2' : begin
                  if f2 then s_poke_b (adr2,0)
                    else s_poke_b (adr2,$ff);
                end;
          'q','Q' : return_flag:=true;
        end;
  until return_flag;
return_flag :=false;
cls;
END;

{************* Funktionstasten lesen *************************}

PROCEDURE read_kbd;

BEGIN
  l:=2;
  taste:=bconin(l);
  taste:=shr(taste,$10);
  tas  :=ord(chr(taste & $FF));
END;

{************************************************************}

PROCEDURE head(cluster,rel_sec: integer;
               VAR side,track,abs_sec: integer);

BEGIN
  abs_sec:=rel_sec mod 9+1;
  if cluster < 400
  then
    BEGIN
      side:=0;
      track:=rel_sec div 9;
    END
  else
    BEGIN
      track:=rel_sec div 18;
      side:=(rel_sec div 9) & 1;
   END;
END;

{********* Floppy- & Ausgabe-Wahl ***************************}

PROCEDURE lauf_werk;

BEGIN
  cls;
  gotoxy(10,5);
  write('Bitte  Laufwerk  eingeben   :');
  invers_on;
  gotoxy(25,7);
  write('<A>');
  invers_off;
  write(' oder <B> :  ');
  read(laufw);
  gotoxy(10,10);
  write('Bitte Ausgabegert eingeben : ');
  invers_on;
  gotoxy(10,12);
  write('<B>');
  invers_off;
  write('ildschirm oder <D>rucker :  ');
  read(ausga);
  if ausga='d' then ausga:='D';
  if ausga='D' then
    rewrite (output,'LST:')
  else
   BEGIN
    rewrite (output,'CON:');
    cls;
   END;
   case laufw of
    'a','A'   :BEGIN
                 lw:=0;
                 laufw:='A';
               END;
    'b','B'   :BEGIN
                 lw:=1;
                 laufw:='B';
               END;
    otherwise :BEGIN
                 lw:=0;
                 laufw:='A';
               END;
  END;
END;

{*********** Disc - Parameter ***************************}

PROCEDURE para_bios;

VAR
  s,j,i : integer;

BEGIN
  lauf_werk;
  writeln('Parameterblock von Drive ',laufw,' :');
  writeln;
  bpb:=get_bpb(lw);
  writeln('Bytes/Sector       :',bpb^[1]:6);
  writeln('Sectors/Cluster    :',bpb^[2]:6);
  writeln('Bytes/Cluster      :',bpb^[3]:6);
  writeln('Sectors/Directory  :',bpb^[4]:6);
  writeln('Sectors/FAT        :',bpb^[5]:6);
  writeln('Begin FAT 2        :',bpb^[6]:6);
  writeln('Begin Data         :',bpb^[7]:6);
  writeln('Datencluster/Disk  :',bpb^[8]:6);
  writeln('Flag-Wort (hex)    :',bpb^[9]:6);
  writeln;
  fat_2   :=bpb^[6];
  fat_1   :=fat_2-bpb^[5];
  dir     :=fat_2+bpb^[5];
  daten   :=bpb^[7];
  clusters:=bpb^[8];
  writeln('Somit gilt:');
  writeln('             Rel_Sector  Side / Track / Sector');
  head(clusters,fat_1,side,track,abs_sec);
  writeln('FAT1      :',fat_1:8,side:8,track:8,abs_sec:8);
  head(clusters,fat_2,side,track,abs_sec);
  writeln('FAT2      :',fat_2:8,side:8,track:8,abs_sec:8);
  head(clusters,dir,side,track,abs_sec);
  dir_side :=side;
  dir_sec  :=abs_sec;
  dir_track:=track;
  writeln('Directory :',dir:8,side:8,track:8,abs_sec:8);
  head(clusters,daten,side,track,abs_sec);
  writeln('Daten     :',daten:8,side:8,track:8,abs_sec:8);
 new_page;
  for s:=dir_sec to dir_sec+6 do
    e:=floprd(dir_buf[s],0,lw,s,dir_track,dir_side,1);
  for s:=dir_sec to dir_sec+6 do
    BEGIN
      writeln;
      writeln;
      writeln('Directory Sector #',s-dir_sec+1);
      writeln;
      for i:=1 to 16 do
        BEGIN
          write(i:3,': ');
          k:=dir_buf[s,i,0];
          write(k:2:h,'  ');
          if (k=0)
            then write(' ':19)
            else
              BEGIN
                for j:=0 to 7 do
                  write(chr(dir_buf[s,i,j]));  {name}
                write(' ');
                for j:=8 to 10 do
                  write(chr(dir_buf[s,i,j]));  {extension}
                                               {size:}
                write('   ',dir_buf[s,i,28]+256*dir_buf[s,i,29]
                   +65536*(dir_buf[s,i,30]+256*dir_buf[s,i,31]):7);
                                                {start cluster}
                write(dir_buf[s,i,26]+256*dir_buf[s,i,27]:8);
              END;
          if k=$E5 then write('   <Deleted>');
          if k=$2E then write('   <DIR>');
          if k=$00 then write('   <Free>');
          writeln;
        END;
    new_page;
    END;
END;

PROCEDURE file_allo;

VAR
  s,j,i : integer;

BEGIN
  lauf_werk;
  bpb     :=get_bpb(lw);
  dir     :=bpb^[5]+bpb^[6];
  clusters:=bpb^[8];
  head(clusters,dir,side,track,abs_sec);
  for s:=abs_sec to abs_sec+6 do
    e:=floprd(dir_buf[s],0,lw,s,track,side,1);
  e:=fatrd(fat,0,lw,2,0,0,5);
  for s:=abs_sec to abs_sec+6 do
    BEGIN
      for i:=1 to 16 do
        BEGIN
          k:=dir_buf[s,i,0];
          if (k<>0) and (k<>$2E) and (k<>$E5) then
            BEGIN
              for j:=0 to 7 do
                write(chr(dir_buf[s,i,j]));
              write(' ');
              for j:=8 to 10 do
                write(chr(dir_buf[s,i,j]));
              write(' : ');
              last_cluster:=dir_buf[s,i,26]+dir_buf[s,i,27]*256;
              while last_cluster<$FF0 do
                BEGIN
                  write(last_cluster:4);
                  last_cluster:=next_cluster(last_cluster);
                END;
              writeln;
            END;
        END;
    END;
new_page;
END;

{******** Location of Subdirectories *******************}

PROCEDURE direct;

VAR
  s,i,i1,j : integer;

BEGIN
  i1:=0;
  lauf_werk;
  bpb     :=get_bpb(lw);
  dir     :=bpb^[5]+bpb^[6];
  clusters:=bpb^[8];
  head(clusters,dir,side,track,abs_sec);
  for s:=abs_sec to abs_sec+6 do
    e:=floprd(dir_buf[s],0,lw,s,track,side,1);
  e:=fatrd(fat,0,lw,2,0,0,5);
  for s:=abs_sec to abs_sec+6 do
    BEGIN
      for i:=1 to 16 do
        BEGIN
          size:=dir_buf[s,i,28]+256*dir_buf[s,i,29]
                   +65536*(dir_buf[s,i,30]+256*dir_buf[s,i,31]);
          k:=dir_buf[s,i,0];
          if (k<>0) and (k<>$2E) and (k<>$E5) and (size=0) then
            BEGIN
              write('Directory ');
              for j:=0 to 7 do
                write(chr(dir_buf[s,i,j]));
              write(' ');
              for j:=8 to 10 do
                write(chr(dir_buf[s,i,j]));
              writeln;
              last_cluster:=dir_buf[s,i,26]+256*dir_buf[s,i,27];
              writeln('Startet bei Cluster ',last_cluster);
              rel_sec:=(last_cluster-2)*bpb^[2]+bpb^[7];
              writeln('Das ist relativer Sektor Nr.',rel_sec:4);
              head(clusters,rel_sec,side,track,abs_sec);
              writeln('oder Seite':28,side:4);
              writeln('Track':28,track:4);
              writeln('Sektor':28,abs_sec:4);
              writeln;
              i1:=i1+1
            END;
              IF i1=3 then
                BEGIN
                  new_page;
                  i1:=0;
                END;
        END;
    END;
new_page;
END;

{##################  M A I N  -  Program  ####################}

BEGIN   {main}
  REPEAT
    x:=21;
    y:=8;
    rewrite (output,'CON:');
    cls;
    cur_off;
    gotoxy(13,2);
    invers_on;
    write(' DISK - UTILITY  v1.0 :  by RN & RW, September 1986 ');
    invers_off;
    gotoxy(26,6);
    writeln('* * *  M E N U E  * * *');
    gotoxy(x,y);
    write('Bios - Parameter - Block      ');
    invers_on;
    write('<F1>');
    invers_off;
    y:=y+2;
    gotoxy(x,y);
    write('File - Allocation - Table     ');
    invers_on;
    write('<F2>');
    invers_off;
    y:=y+2;
    gotoxy(x,y);
    write('Location of Sub-Directories   ');
    invers_on;
    write('<F3>');
    invers_off;
    y:=y+2;
    gotoxy(x,y);
    write('Disk-Parameter-Einstellung    ');
    invers_on;
    write('<F4>');
    invers_off;
    y:=y+2;
    gotoxy(x,y);
    write('Programm - Ende  => DESKTOP   ');
    invers_on;
    write('<F5>');
    invers_off;
    writeln;
    read_kbd;
    cur_on;
    case tas of
      59 :para_bios;
      60 :file_allo;
      61 :direct;
      62 :disk_j;
      63 :return_flag:=true;
    END;
  UNTIL return_flag;
END. {########  END of MAIN  #################################}

